//+------------------------------------------------------------------+
//|                                       Darvas Box (by Dark67).mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Dark67"
#property link      "not yet"

#property indicator_chart_window

   extern color THigh=MediumBlue;
   extern color TLow=Yellow;
   extern int NumberOfLevels=3;

   datetime T1,T2;
   int N;
   int k;
   int Num;
   string Name;
   double MAX, MIN, MAXP, MINP;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(EMPTY,OBJ_RECTANGLE);
   ObjectsDeleteAll(EMPTY,OBJ_FIBO);
   Comment("\n","\n");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
//------
   if (counted_bars==0)
         {
         ObjectsDeleteAll(EMPTY,OBJ_RECTANGLE);
         ObjectsDeleteAll(EMPTY,OBJ_FIBO);
         k=0;
         Num=1;
         N=Bars-1;
         MAX=iHigh(NULL,0,N);
         MIN=iLow(NULL,0,N);
         Name="Rectangle"+Num;
         ObjectCreate(Name,OBJ_RECTANGLE,0,Time[N],MAX,Time[N],MIN);
         ObjectSet( Name,OBJPROP_COLOR,SaddleBrown);
         }
//----
   N=Bars-counted_bars-1;
   while(N>0)
      {
      switch(k)
         {
         case 0:
            {
            if(MAX<iHigh(NULL,0,N)||MIN>iLow(NULL,0,N))
                     {k=1;MAX=iHigh(NULL,0,N);T1=Time[N];}
                  else
                     {
                     ObjectSet( Name,OBJPROP_TIME2,Time[N-1]);
                     }
            }
            break;
         case 1:
            {
            if(MAX<=iHigh(NULL,0,N))
                     {MAX=iHigh(NULL,0,N);}
                     else 
                        {k=2;}
            }
            break;
         case 2:
            {
            if(MAX<=iHigh(NULL,0,N))
                     {k=1;MAX=iHigh(NULL,0,N);}
                     else {k=3;MIN=iLow(NULL,0,N);}
            }
            break;
         case 3:
            {
            if(MAX<=iHigh(NULL,0,N))
                     {k=1;MAX=iHigh(NULL,0,N);}
                     else
                           {
                           if(MIN>=iLow(NULL,0,N)) {MIN=iLow(NULL,0,N);}
                                 else
                                    {
                                       k=0;MAXP=MAX; MINP=MIN;
                                       Num=Num+1;
                                       Name="Rectangle"+Num;
                                       ObjectCreate(Name,OBJ_RECTANGLE,0,T1,MAXP,Time[N-1],MINP);
                                       ObjectSet( Name,OBJPROP_COLOR,SaddleBrown);
                                       double T_High1=MAXP+0.5*(MAXP-MINP);
                                       double T_Low1=MINP-0.5*(MAXP-MINP);
                                       double T_High2=2*MAXP-MINP;
                                       double T_Low2=2*MINP-MAXP;
                                       double T_High3=MAXP+1.618*(MAXP-MINP);
                                       double T_Low3=MINP-1.618*(MAXP-MINP);
                                       ObjectDelete("TLineMax1");
                                       ObjectDelete("TLineMin1");
                                       ObjectCreate("TLineMax1",OBJ_FIBO,0,T1,MAXP,T1,MINP);
                                       ObjectSet("TLineMax1",OBJPROP_COLOR,-1);
                                       ObjectSet("TLineMax1",OBJPROP_LEVELCOLOR,THigh);
                                       ObjectSet("TLineMax1",OBJPROP_FIBOLEVELS,NumberOfLevels+1);
                                       ObjectCreate("TLineMin1",OBJ_FIBO,0,T1,MINP,T1,MAXP);
                                       ObjectSet("TLineMin1",OBJPROP_COLOR,-1);
                                       ObjectSet("TLineMin1",OBJPROP_LEVELCOLOR,TLow);
                                       ObjectSet("TLineMin1",OBJPROP_FIBOLEVELS,NumberOfLevels+1);
                                       ObjectSet("TLineMax1",OBJPROP_FIRSTLEVEL+0,1);
                                       ObjectSetFiboDescription("TLineMax1",0,DoubleToStr(MAXP,Digits));
                                       ObjectSet("TLineMin1",OBJPROP_FIRSTLEVEL+0,1);
                                       ObjectSetFiboDescription("TLineMin1",0,DoubleToStr(MINP,Digits));
                                       if (NumberOfLevels>0)
                                       {
                                       ObjectSet("TLineMax1",OBJPROP_FIRSTLEVEL+1,1.5);
                                       ObjectSetFiboDescription("TLineMax1",1,"T1-  "+DoubleToStr(T_High1,Digits));
                                       ObjectSet("TLineMin1",OBJPROP_FIRSTLEVEL+1,1.5);
                                       ObjectSetFiboDescription("TLineMin1",1,"T1-  "+DoubleToStr(T_Low1,Digits));
                                       }
                                       if (NumberOfLevels>1)
                                       {
                                       ObjectSet("TLineMax1",OBJPROP_FIRSTLEVEL+2,2);
                                       ObjectSetFiboDescription("TLineMax1",2,"T2-  "+DoubleToStr(T_High2,Digits));
                                       ObjectSet("TLineMin1",OBJPROP_FIRSTLEVEL+2,2);
                                       ObjectSetFiboDescription("TLineMin1",2,"T2-  "+DoubleToStr(T_Low2,Digits));
                                       }
                                       if (NumberOfLevels>2)
                                       {
                                       ObjectSet("TLineMax1",OBJPROP_FIRSTLEVEL+3,2.618);
                                       ObjectSetFiboDescription("TLineMax1",3,"T3-  "+DoubleToStr(T_High3,Digits));
                                       ObjectSet("TLineMin1",OBJPROP_FIRSTLEVEL+3,2.618);
                                       ObjectSetFiboDescription("TLineMin1",3,"T3-  "+DoubleToStr(T_Low3,Digits));
                                       }
                                    }
                           }
            }
            break;
         }
         N--;
         if (N==0)
            {
            Comment ("Darvas Box by Dark67","\n",
                     "  : ",Bars);
            }
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+